(*type action = Ast | Interpret | Bytecode | Compile*)
(* ("-i", Interpret);
("-b", Bytecode);
  | Interpret -> ignore (Interpret.run program)
  | Bytecode -> let listing =
      Bytecode.string_of_prog (Compile.translate program)
    in print_endline listing
  | Compile -> Execute.execute_prog (Compile.translate program)
*)

type action = Ast | Compile

let _ =
  let action = if Array.length Sys.argv > 1 then
    List.assoc Sys.argv.(1) [ ("-a", Ast);
			      ("-c", Compile) ]
  else Compile in
  let filename = if Array.length Sys.argv > 2 then
  	Sys.argv.(2) else "LaMesa_" ^ string_of_int (Random.int 100) ^ ".js" in
  let lexbuf = Lexing.from_channel stdin in
  let program = Parser.program Scanner.token lexbuf in
  match action with
    Ast -> let listing = Ast.string_of_program program
           in print_string listing
  | Compile -> let outfile = open_out filename in 
  						 output_string outfile (Compile.translate program)

